/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "accounts.h"

/* globals for accounts */
gint Accounts_reread;

/* external variables */
extern gchar *spruceconf;                /* spruce config file name */
extern GtkWidget *frmAccounts;
extern gboolean AccountsOpen;            /* is frmAccounts opened?? */
extern GtkWidget *frmOptions;
extern gboolean OptionsOpen;
extern GList *PopAccounts;
extern GList *ImapAccounts;
extern gint first_time;

extern GtkWidget *frmMain;              /* for use when creating the combo box of Mailboxes */


static gboolean PopEditorOpen = FALSE;
static gboolean ImapEditorOpen = FALSE;
static gint clistPopAccount_row = -1;
static gint clistImapAccount_row = -1;
static gpointer pop_current = NULL;
static gboolean pop_add = FALSE;
static gpointer imap_current = NULL;
static gboolean imap_add = FALSE;

/* constructors */
/*static PopAccount_t *new_PopAccount()
{
   PopAccount_t *pop;

   pop = g_malloc(sizeof(PopAccount_t));
   pop->server.hostname = NULL;
   pop->server.port = 110;
   pop->login = NULL;
   pop->passwd = NULL;
   pop->mailbox = NULL;
   pop->delemail = TRUE;

   return pop;
}

static ImapAccount_t *new_ImapAccount()
{
   ImapAccount_t *imap;

   imap = g_malloc0(sizeof(ImapAccount_t));
   imap->server.hostname = NULL;
   imap->server.port = 143;
   imap->login = NULL;
   imap->passwd = NULL;
   imap->namespace = NULL;

   return imap;
}*/


GtkWidget* create_frmAccounts (gint readAccounts)
{
  GtkWidget *frmAccounts;
  GtkWidget *fixed1;
  GtkWidget *scrollPopAccounts;
  GtkWidget *clistPopAccounts;
  GtkWidget *lblPopServer;
  GtkWidget *lblPopPort;
  GtkWidget *lblPopAuth;
  GtkWidget *lblPopLogin;
  GtkWidget *lblPopMailbox;
  GtkWidget *lblPopDelete;
  GtkWidget *cmdPopAdd;
  GtkWidget *cmdPopEdit;
  GtkWidget *cmdPopDelete;
  GtkWidget *lblPopAccounts;
  GtkWidget *lblImapAccounts;
  GtkWidget *scrollImapAccounts;
  GtkWidget *clistImapAccounts;
  GtkWidget *lblImapServer;
  GtkWidget *lblImapPort;
  GtkWidget *lblImapAuth;
  GtkWidget *lblImapLogin;
  GtkWidget *lblImapNamespace;
  GtkWidget *cmdImapAdd;
  GtkWidget *cmdImapEdit;
  GtkWidget *cmdImapDelete;
  GtkWidget *cmdAccountsCancel;
  GtkWidget *cmdAccountsOK;

  frmAccounts = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (frmAccounts, "frmAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "frmAccounts", frmAccounts);
  gtk_widget_set_usize (frmAccounts, 550, 365);
  gtk_container_border_width (GTK_CONTAINER (frmAccounts), 5);
  gtk_signal_connect_object (GTK_OBJECT (frmAccounts), "destroy",
                             GTK_SIGNAL_FUNC (on_frmAccounts_destroy),
                             GTK_OBJECT (frmAccounts));
  gtk_signal_connect_object (GTK_OBJECT (frmAccounts), "show",
                             GTK_SIGNAL_FUNC (on_frmAccounts_show),
                             GTK_OBJECT (frmAccounts));
  gtk_window_set_title (GTK_WINDOW (frmAccounts), _("Spruce: Incoming Mail Accounts"));
  gtk_window_set_policy (GTK_WINDOW (frmAccounts), FALSE, FALSE, FALSE);

  fixed1 = gtk_fixed_new ();
  gtk_widget_set_name (fixed1, "fixed1");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "fixed1", fixed1);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (frmAccounts), fixed1);

  scrollPopAccounts = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrollPopAccounts, "scrollPopAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "scrollPopAccounts", scrollPopAccounts);
  gtk_widget_show (scrollPopAccounts);
  gtk_fixed_put (GTK_FIXED (fixed1), scrollPopAccounts, 0, 16);
  gtk_widget_set_uposition (scrollPopAccounts, 0, 16);
  gtk_widget_set_usize (scrollPopAccounts, 448, 136);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollPopAccounts), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clistPopAccounts = gtk_clist_new (6);
  gtk_widget_set_name (clistPopAccounts, "clistPopAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "clistPopAccounts", clistPopAccounts);
  gtk_widget_show (clistPopAccounts);
  gtk_container_add (GTK_CONTAINER (scrollPopAccounts), clistPopAccounts);
  gtk_widget_set_usize (clistPopAccounts, 440, 144);
  gtk_signal_connect (GTK_OBJECT (clistPopAccounts), "select_row",
                      GTK_SIGNAL_FUNC (on_clistPopAccounts_select_row),
                      NULL);
  gtk_clist_set_column_width (GTK_CLIST (clistPopAccounts), 0, 100);
  gtk_clist_set_column_width (GTK_CLIST (clistPopAccounts), 1, 26);
  gtk_clist_set_column_width (GTK_CLIST (clistPopAccounts), 2, 65);
  gtk_clist_set_column_width (GTK_CLIST (clistPopAccounts), 3, 82);
  gtk_clist_set_column_width (GTK_CLIST (clistPopAccounts), 4, 83);
  gtk_clist_set_column_width (GTK_CLIST (clistPopAccounts), 5, 36);
  gtk_clist_column_titles_show (GTK_CLIST (clistPopAccounts));

  lblPopServer = gtk_label_new (_("Server"));
  gtk_widget_set_name (lblPopServer, "lblPopServer");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopServer", lblPopServer);
  gtk_widget_show (lblPopServer);
  gtk_clist_set_column_widget (GTK_CLIST (clistPopAccounts), 0, lblPopServer);

  lblPopPort = gtk_label_new (_("Port"));
  gtk_widget_set_name (lblPopPort, "lblPopPort");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopPort", lblPopPort);
  gtk_widget_show (lblPopPort);
  gtk_clist_set_column_widget (GTK_CLIST (clistPopAccounts), 1, lblPopPort);

  lblPopAuth = gtk_label_new (_("Auth"));
  gtk_widget_set_name (lblPopAuth, "lblPopAuth");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopAuth", lblPopAuth);
  gtk_widget_show (lblPopAuth);
  gtk_clist_set_column_widget (GTK_CLIST (clistPopAccounts), 2, lblPopAuth);

  lblPopLogin = gtk_label_new (_("Login"));
  gtk_widget_set_name (lblPopLogin, "lblPopLogin");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopLogin", lblPopLogin);
  gtk_widget_show (lblPopLogin);
  gtk_clist_set_column_widget (GTK_CLIST (clistPopAccounts), 3, lblPopLogin);

  lblPopMailbox = gtk_label_new (_("Mailbox"));
  gtk_widget_set_name (lblPopMailbox, "lblPopMailbox");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopMailbox", lblPopMailbox);
  gtk_widget_show (lblPopMailbox);
  gtk_clist_set_column_widget (GTK_CLIST (clistPopAccounts), 4, lblPopMailbox);

  lblPopDelete = gtk_label_new (_("Delete"));
  gtk_widget_set_name (lblPopDelete, "lblPopDelete");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopDelete", lblPopDelete);
  gtk_widget_show (lblPopDelete);
  gtk_clist_set_column_widget (GTK_CLIST (clistPopAccounts), 5, lblPopDelete);

  cmdPopAdd = gtk_button_new_with_label (_("Add"));
  gtk_widget_set_name (cmdPopAdd, "cmdPopAdd");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdPopAdd", cmdPopAdd);
  gtk_widget_show (cmdPopAdd);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdPopAdd, 456, 16);
  gtk_widget_set_uposition (cmdPopAdd, 456, 16);
  gtk_widget_set_usize (cmdPopAdd, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdPopAdd), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdPopAdd_clicked),
                             GTK_OBJECT (frmAccounts));

  cmdPopEdit = gtk_button_new_with_label (_("Edit"));
  gtk_widget_set_name (cmdPopEdit, "cmdPopEdit");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdPopEdit", cmdPopEdit);
  gtk_widget_show (cmdPopEdit);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdPopEdit, 456, 48);
  gtk_widget_set_uposition (cmdPopEdit, 456, 48);
  gtk_widget_set_usize (cmdPopEdit, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdPopEdit), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdPopEdit_clicked),
                             GTK_OBJECT (frmAccounts));

  cmdPopDelete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_set_name (cmdPopDelete, "cmdPopDelete");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdPopDelete", cmdPopDelete);
  gtk_widget_show (cmdPopDelete);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdPopDelete, 456, 80);
  gtk_widget_set_uposition (cmdPopDelete, 456, 80);
  gtk_widget_set_usize (cmdPopDelete, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdPopDelete), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdPopDelete_clicked),
                             GTK_OBJECT (frmAccounts));

  lblPopAccounts = gtk_label_new (_("POP Accounts"));
  gtk_widget_set_name (lblPopAccounts, "lblPopAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblPopAccounts", lblPopAccounts);
  gtk_widget_show (lblPopAccounts);
  gtk_fixed_put (GTK_FIXED (fixed1), lblPopAccounts, 8, 0);
  gtk_widget_set_uposition (lblPopAccounts, 8, 0);
  gtk_widget_set_usize (lblPopAccounts, 216, 16);
  gtk_label_set_justify (GTK_LABEL (lblPopAccounts), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblPopAccounts), 0, 0.5);

  lblImapAccounts = gtk_label_new (_("IMAP Accounts"));
  gtk_widget_set_name (lblImapAccounts, "lblImapAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblImapAccounts", lblImapAccounts);
  gtk_widget_show (lblImapAccounts);
  gtk_fixed_put (GTK_FIXED (fixed1), lblImapAccounts, 8, 160);
  gtk_widget_set_uposition (lblImapAccounts, 8, 160);
  gtk_widget_set_usize (lblImapAccounts, 208, 16);
  gtk_label_set_justify (GTK_LABEL (lblImapAccounts), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblImapAccounts), 0, 0.5);

  scrollImapAccounts = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrollImapAccounts, "scrollImapAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "scrollImapAccounts", scrollImapAccounts);
  gtk_widget_show (scrollImapAccounts);
  gtk_fixed_put (GTK_FIXED (fixed1), scrollImapAccounts, 0, 176);
  gtk_widget_set_uposition (scrollImapAccounts, 0, 176);
  gtk_widget_set_usize (scrollImapAccounts, 448, 136);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollImapAccounts), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clistImapAccounts = gtk_clist_new (5);
  gtk_widget_set_name (clistImapAccounts, "clistImapAccounts");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "clistImapAccounts", clistImapAccounts);
  gtk_widget_show (clistImapAccounts);
  gtk_container_add (GTK_CONTAINER (scrollImapAccounts), clistImapAccounts);
  gtk_signal_connect (GTK_OBJECT (clistImapAccounts), "select_row",
                      GTK_SIGNAL_FUNC (on_clistImapAccounts_select_row),
                      NULL);
  gtk_clist_set_column_width (GTK_CLIST (clistImapAccounts), 0, 100);
  gtk_clist_set_column_width (GTK_CLIST (clistImapAccounts), 1, 26);
  gtk_clist_set_column_width (GTK_CLIST (clistImapAccounts), 2, 65);
  gtk_clist_set_column_width (GTK_CLIST (clistImapAccounts), 3, 83);
  gtk_clist_set_column_width (GTK_CLIST (clistImapAccounts), 4, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clistImapAccounts));

  lblImapServer = gtk_label_new (_("Server"));
  gtk_widget_set_name (lblImapServer, "lblImapServer");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblImapServer", lblImapServer);
  gtk_widget_show (lblImapServer);
  gtk_clist_set_column_widget (GTK_CLIST (clistImapAccounts), 0, lblImapServer);

  lblImapPort = gtk_label_new (_("Port"));
  gtk_widget_set_name (lblImapPort, "lblImapPort");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblImapPort", lblImapPort);
  gtk_widget_show (lblImapPort);
  gtk_clist_set_column_widget (GTK_CLIST (clistImapAccounts), 1, lblImapPort);

  lblImapAuth = gtk_label_new (_("Auth"));
  gtk_widget_set_name (lblImapAuth, "lblImapAuth");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblImapAuth", lblImapAuth);
  gtk_widget_show (lblImapAuth);
  gtk_clist_set_column_widget (GTK_CLIST (clistImapAccounts), 2, lblImapAuth);

  lblImapLogin = gtk_label_new (_("Login"));
  gtk_widget_set_name (lblImapLogin, "lblImapLogin");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblImapLogin", lblImapLogin);
  gtk_widget_show (lblImapLogin);
  gtk_clist_set_column_widget (GTK_CLIST (clistImapAccounts), 3, lblImapLogin);

  lblImapNamespace = gtk_label_new (_("Namespace"));
  gtk_widget_set_name (lblImapNamespace, "lblImapNamespace");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "lblImapNamespace", lblImapNamespace);
  gtk_widget_show (lblImapNamespace);
  gtk_clist_set_column_widget (GTK_CLIST (clistImapAccounts), 4, lblImapNamespace);

  cmdImapAdd = gtk_button_new_with_label (_("Add"));
  gtk_widget_set_name (cmdImapAdd, "cmdImapAdd");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdImapAdd", cmdImapAdd);
  gtk_widget_show (cmdImapAdd);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdImapAdd, 456, 176);
  gtk_widget_set_uposition (cmdImapAdd, 456, 176);
  gtk_widget_set_usize (cmdImapAdd, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdImapAdd), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdImapAdd_clicked),
                             GTK_OBJECT (frmAccounts));

  cmdImapEdit = gtk_button_new_with_label (_("Edit"));
  gtk_widget_set_name (cmdImapEdit, "cmdImapEdit");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdImapEdit", cmdImapEdit);
  gtk_widget_show (cmdImapEdit);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdImapEdit, 456, 208);
  gtk_widget_set_uposition (cmdImapEdit, 456, 208);
  gtk_widget_set_usize (cmdImapEdit, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdImapEdit), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdImapEdit_clicked),
                             GTK_OBJECT (frmAccounts));

  cmdImapDelete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_set_name (cmdImapDelete, "cmdImapDelete");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdImapDelete", cmdImapDelete);
  gtk_widget_show (cmdImapDelete);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdImapDelete, 456, 240);
  gtk_widget_set_uposition (cmdImapDelete, 456, 240);
  gtk_widget_set_usize (cmdImapDelete, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdImapDelete), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdImapDelete_clicked),
                             GTK_OBJECT (frmAccounts));

  cmdAccountsCancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cmdAccountsCancel, "cmdAccountsCancel");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdAccountsCancel", cmdAccountsCancel);
  gtk_widget_show (cmdAccountsCancel);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdAccountsCancel, 456, 320);
  gtk_widget_set_uposition (cmdAccountsCancel, 456, 320);
  gtk_widget_set_usize (cmdAccountsCancel, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdAccountsCancel), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdAccountsCancel_clicked),
                             GTK_OBJECT (frmAccounts));

  cmdAccountsOK = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (cmdAccountsOK, "cmdAccountsOK");
  gtk_object_set_data (GTK_OBJECT (frmAccounts), "cmdAccountsOK", cmdAccountsOK);
  gtk_widget_show (cmdAccountsOK);
  gtk_fixed_put (GTK_FIXED (fixed1), cmdAccountsOK, 368, 320);
  gtk_widget_set_uposition (cmdAccountsOK, 368, 320);
  gtk_widget_set_usize (cmdAccountsOK, 80, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdAccountsOK), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdAccountsOK_clicked),
                             GTK_OBJECT (frmAccounts));


  Accounts_reread = readAccounts;
 
  return frmAccounts;
}

GtkWidget* create_dlgPopEditor (PopAccount_t *pop)
{
  GtkWidget *dlgPopEditor;
  GtkWidget *dialog_vbox1;
  GtkWidget *fixed1;
  GtkWidget *notebook;
  GtkWidget *fixed3;
  GtkObject *spinPort_adj;
  GtkWidget *spinPort;
  GtkWidget *txtServerName;
  GtkWidget *lblPort;
  GtkWidget *txtUserName;
  GtkWidget *lblUserName;
  GtkWidget *lblPassword;
  GtkWidget *txtPasswd;
  GtkWidget *chkDeleteMail;
  GtkWidget *lblDefaultMailbox;
  GtkWidget *cmboMailbox;
  GtkWidget *lblServerName;
  GtkWidget *fixed4;
  GtkWidget *lblAuth;
  GtkWidget *cmboAuthentication;
  GList *cmboAuthentication_items = NULL;
  GtkWidget *lblGeneral;
  GtkWidget *lblAdvanced;
  GtkWidget *dialog_action_area1;
  GtkWidget *fixed2;
  GtkWidget *cmdPopEditorCancel;
  GtkWidget *cmdPopEditorOK;
  GtkWidget *treelocalBoxes = get_widget(frmMain, "treelocalBoxes");
  GList *cmboMailbox_items = NULL;
  GList *items = NULL;
  gchar *mailbox;

  dlgPopEditor = gtk_dialog_new ();
  gtk_widget_set_name (dlgPopEditor, "dlgPopEditor");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "dlgPopEditor", dlgPopEditor);
  gtk_widget_set_usize (dlgPopEditor, 400, 356);
  gtk_signal_connect_object (GTK_OBJECT (dlgPopEditor), "destroy",
                             GTK_SIGNAL_FUNC (on_dlgPopEditor_destroy),
                             GTK_OBJECT (dlgPopEditor));
  gtk_window_set_title (GTK_WINDOW (dlgPopEditor), _("Spruce: POP Editor"));
  gtk_window_position (GTK_WINDOW (dlgPopEditor), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (dlgPopEditor), FALSE, FALSE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dlgPopEditor)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  fixed1 = gtk_fixed_new ();
  gtk_widget_set_name (fixed1, "fixed1");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "fixed1", fixed1);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), fixed1, TRUE, TRUE, 0);

  notebook = gtk_notebook_new ();
  gtk_widget_set_name (notebook, "notebook");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "notebook", notebook);
  gtk_widget_show (notebook);
  gtk_fixed_put (GTK_FIXED (fixed1), notebook, 8, 8);
  gtk_widget_set_uposition (notebook, 8, 8);
  gtk_widget_set_usize (notebook, 384, 280);

  fixed3 = gtk_fixed_new ();
  gtk_widget_set_name (fixed3, "fixed3");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "fixed3", fixed3);
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (notebook), fixed3);

  if (pop && pop->server.port)
     spinPort_adj = gtk_adjustment_new (pop->server.port, 1, 65535, 1, 10, 10);
  else
     spinPort_adj = gtk_adjustment_new (110, 1, 65535, 1, 10, 10);
  spinPort = gtk_spin_button_new (GTK_ADJUSTMENT (spinPort_adj), 1, 0);
  gtk_widget_set_name (spinPort, "spinPort");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "spinPort", spinPort);
  gtk_widget_show (spinPort);
  gtk_fixed_put (GTK_FIXED (fixed3), spinPort, 112, 48);
  gtk_widget_set_uposition (spinPort, 112, 48);
  gtk_widget_set_usize (spinPort, 72, 24);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinPort), TRUE);

  txtServerName = gtk_entry_new ();
  gtk_widget_set_name (txtServerName, "txtServerName");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "txtServerName", txtServerName);
  gtk_widget_show (txtServerName);
  gtk_fixed_put (GTK_FIXED (fixed3), txtServerName, 112, 16);
  gtk_widget_set_uposition (txtServerName, 112, 16);
  gtk_widget_set_usize (txtServerName, 256, 24);
  if (pop && pop->server.hostname)
     gtk_entry_set_text(GTK_ENTRY(txtServerName), pop->server.hostname);

  lblPort = gtk_label_new (_("Port:"));
  gtk_widget_set_name (lblPort, "lblPort");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblPort", lblPort);
  gtk_widget_show (lblPort);
  gtk_fixed_put (GTK_FIXED (fixed3), lblPort, 8, 48);
  gtk_widget_set_uposition (lblPort, 8, 48);
  gtk_widget_set_usize (lblPort, 96, 24);
  gtk_label_set_justify (GTK_LABEL (lblPort), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblPort), 1.93715e-07, 0.5);

  txtUserName = gtk_entry_new ();
  gtk_widget_set_name (txtUserName, "txtUserName");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "txtUserName", txtUserName);
  gtk_widget_show (txtUserName);
  gtk_fixed_put (GTK_FIXED (fixed3), txtUserName, 112, 80);
  gtk_widget_set_uposition (txtUserName, 112, 80);
  gtk_widget_set_usize (txtUserName, 256, 24);
  if (pop && pop->login)
     gtk_entry_set_text(GTK_ENTRY(txtUserName), pop->login);

  lblUserName = gtk_label_new (_("User Name:"));
  gtk_widget_set_name (lblUserName, "lblUserName");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblUserName", lblUserName);
  gtk_widget_show (lblUserName);
  gtk_fixed_put (GTK_FIXED (fixed3), lblUserName, 8, 80);
  gtk_widget_set_uposition (lblUserName, 8, 80);
  gtk_widget_set_usize (lblUserName, 96, 24);
  gtk_label_set_justify (GTK_LABEL (lblUserName), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblUserName), 1.93715e-07, 0.5);

  lblPassword = gtk_label_new (_("Password:"));
  gtk_widget_set_name (lblPassword, "lblPassword");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblPassword", lblPassword);
  gtk_widget_show (lblPassword);
  gtk_fixed_put (GTK_FIXED (fixed3), lblPassword, 8, 112);
  gtk_widget_set_uposition (lblPassword, 8, 112);
  gtk_widget_set_usize (lblPassword, 96, 24);
  gtk_label_set_justify (GTK_LABEL (lblPassword), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblPassword), 1.93715e-07, 0.5);

  txtPasswd = gtk_entry_new ();
  gtk_widget_set_name (txtPasswd, "txtPasswd");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "txtPasswd", txtPasswd);
  gtk_widget_show (txtPasswd);
  gtk_fixed_put (GTK_FIXED (fixed3), txtPasswd, 112, 112);
  gtk_widget_set_uposition (txtPasswd, 112, 112);
  gtk_widget_set_usize (txtPasswd, 256, 24);
  gtk_entry_set_visibility (GTK_ENTRY (txtPasswd), FALSE);
  if (pop && pop->passwd)
     gtk_entry_set_text(GTK_ENTRY(txtPasswd), pop->passwd);

  chkDeleteMail = gtk_check_button_new_with_label (_("Delete mail from server once it has been downloaded"));
  gtk_widget_set_name (chkDeleteMail, "chkDeleteMail");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "chkDeleteMail", chkDeleteMail);
  gtk_widget_show (chkDeleteMail);
  gtk_fixed_put (GTK_FIXED (fixed3), chkDeleteMail, 8, 216);
  gtk_widget_set_uposition (chkDeleteMail, 8, 216);
  gtk_widget_set_usize (chkDeleteMail, 360, 24);
  if (pop)
     gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (chkDeleteMail), pop->delemail);
  else
     gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (chkDeleteMail), TRUE);

  lblDefaultMailbox = gtk_label_new (_("Deliver Incoming Mail To:"));
  gtk_widget_set_name (lblDefaultMailbox, "lblDefaultMailbox");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblDefaultMailbox", lblDefaultMailbox);
  gtk_widget_show (lblDefaultMailbox);
  gtk_fixed_put (GTK_FIXED (fixed3), lblDefaultMailbox, 8, 184);
  gtk_widget_set_uposition (lblDefaultMailbox, 8, 184);
  gtk_widget_set_usize (lblDefaultMailbox, 168, 24);
  gtk_label_set_justify (GTK_LABEL (lblDefaultMailbox), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblDefaultMailbox), 1.93715e-07, 0.5);

  cmboMailbox = gtk_combo_new ();
  gtk_widget_set_name (cmboMailbox, "cmboMailbox");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "cmboMailbox", cmboMailbox);
  gtk_widget_show (cmboMailbox);
  gtk_fixed_put (GTK_FIXED (fixed3), cmboMailbox, 184, 184);
  gtk_widget_set_uposition (cmboMailbox, 184, 184);
  gtk_widget_set_usize (GTK_COMBO (cmboMailbox)->entry, 168, 24);
  gtk_widget_set_usize (cmboMailbox, 184, 24);
  gtk_combo_set_case_sensitive (GTK_COMBO (cmboMailbox), TRUE);

  items = GTK_TREE (GTK_WIDGET (treelocalBoxes))->children;
  while (items != NULL)
  {
     gtk_label_get (GTK_LABEL (GTK_BIN (GTK_WIDGET(items->data))->child), &mailbox);
     cmboMailbox_items = g_list_append (cmboMailbox_items, mailbox);
     items = items->next;
  }
  if (cmboMailbox_items)
  {
     gtk_combo_set_popdown_strings (GTK_COMBO (cmboMailbox), cmboMailbox_items);
     g_list_free (cmboMailbox_items);
  }
  if (pop && pop->mailbox)
     gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cmboMailbox)->entry), pop->mailbox);

  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(cmboMailbox)->entry), FALSE);
  lblServerName = gtk_label_new (_("Server Name:"));
  gtk_widget_set_name (lblServerName, "lblServerName");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblServerName", lblServerName);
  gtk_widget_show (lblServerName);
  gtk_fixed_put (GTK_FIXED (fixed3), lblServerName, 8, 16);
  gtk_widget_set_uposition (lblServerName, 8, 16);
  gtk_widget_set_usize (lblServerName, 96, 24);
  gtk_label_set_justify (GTK_LABEL (lblServerName), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblServerName), 0, 0.5);

  fixed4 = gtk_fixed_new ();
  gtk_widget_set_name (fixed4, "fixed4");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "fixed4", fixed4);
  gtk_widget_show (fixed4);
  gtk_container_add (GTK_CONTAINER (notebook), fixed4);

  lblAuth = gtk_label_new (_("Authentication:"));
  gtk_widget_set_name (lblAuth, "lblAuth");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblAuth", lblAuth);
  gtk_widget_show (lblAuth);
  gtk_fixed_put (GTK_FIXED (fixed4), lblAuth, 8, 16);
  gtk_widget_set_uposition (lblAuth, 8, 16);
  gtk_widget_set_usize (lblAuth, 120, 24);
  gtk_label_set_justify (GTK_LABEL (lblAuth), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblAuth), 1.93715e-07, 0.5);

  cmboAuthentication = gtk_combo_new ();
  gtk_widget_set_name (cmboAuthentication, "cmboAuthentication");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "cmboAuthentication", cmboAuthentication);
  gtk_widget_show (cmboAuthentication);
  gtk_fixed_put (GTK_FIXED (fixed4), cmboAuthentication, 136, 16);
  gtk_widget_set_uposition (cmboAuthentication, 136, 16);
  gtk_widget_set_usize (GTK_COMBO (cmboAuthentication)->entry, 216, 24);
  gtk_widget_set_usize (cmboAuthentication, 232, 24);
  cmboAuthentication_items = g_list_append (cmboAuthentication_items, _("Plain Text (default)"));
  cmboAuthentication_items = g_list_append (cmboAuthentication_items, _("APOP"));
  cmboAuthentication_items = g_list_append (cmboAuthentication_items, _("CRAM-MD5"));
  gtk_combo_set_popdown_strings (GTK_COMBO (cmboAuthentication), cmboAuthentication_items);
  g_list_free (cmboAuthentication_items);
  if (pop)
  {
     switch (pop->authtype)
     {
        case PLAIN:
           gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry), _("Plain Text (default)"));
           break;
        case APOP:
           gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry), _("APOP"));
           break;
        case CRAM_MD5:
           gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry), _("CRAM-MD5"));
           break;
     }
  }

  lblGeneral = gtk_label_new (_("General"));
  gtk_widget_set_name (lblGeneral, "lblGeneral");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblGeneral", lblGeneral);
  gtk_widget_show (lblGeneral);
  set_notebook_tab (notebook, 0, lblGeneral);

  lblAdvanced = gtk_label_new (_("Advanced"));
  gtk_widget_set_name (lblAdvanced, "lblAdvanced");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "lblAdvanced", lblAdvanced);
  gtk_widget_show (lblAdvanced);
  set_notebook_tab (notebook, 1, lblAdvanced);

  dialog_action_area1 = GTK_DIALOG (dlgPopEditor)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  fixed2 = gtk_fixed_new ();
  gtk_widget_set_name (fixed2, "fixed2");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "fixed2", fixed2);
  gtk_widget_show (fixed2);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), fixed2, TRUE, TRUE, 0);

  cmdPopEditorCancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cmdPopEditorCancel, "cmdPopEditorCancel");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "cmdPopEditorCancel", cmdPopEditorCancel);
  gtk_widget_show (cmdPopEditorCancel);
  gtk_fixed_put (GTK_FIXED (fixed2), cmdPopEditorCancel, 304, 0);
  gtk_widget_set_uposition (cmdPopEditorCancel, 304, 0);
  gtk_widget_set_usize (cmdPopEditorCancel, 72, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdPopEditorCancel), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdPopEditorCancel_clicked),
                             GTK_OBJECT (dlgPopEditor));

  cmdPopEditorOK = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (cmdPopEditorOK, "cmdPopEditorOK");
  gtk_object_set_data (GTK_OBJECT (dlgPopEditor), "cmdPopEditorOK", cmdPopEditorOK);
  gtk_widget_show (cmdPopEditorOK);
  gtk_fixed_put (GTK_FIXED (fixed2), cmdPopEditorOK, 224, 0);
  gtk_widget_set_uposition (cmdPopEditorOK, 224, 0);
  gtk_widget_set_usize (cmdPopEditorOK, 72, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdPopEditorOK), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdPopEditorOK_clicked),
                             GTK_OBJECT (dlgPopEditor));

  return dlgPopEditor;
}

GtkWidget* create_dlgImapEditor (ImapAccount_t *imap)
{
  GtkWidget *dlgImapEditor;
  GtkWidget *dialog_vbox2;
  GtkWidget *fixed1;
  GtkWidget *notebook;
  GtkWidget *fixed3;
  GtkWidget *txtServerName;
  GtkWidget *lblServerName;
  GtkWidget *lblPort;
  GtkObject *spinPort_adj;
  GtkWidget *spinPort;
  GtkWidget *lblUserName;
  GtkWidget *txtUserName;
  GtkWidget *lblPassword;
  GtkWidget *txtPasswd;
  GtkWidget *lblNamespace;
  GtkWidget *txtNamespace;
  GtkWidget *fixed4;
  GtkWidget *lblWhen;
  GtkWidget *lblMoveToTrash;
  GSList *radDeleteMessage_group = NULL;
  GtkWidget *radMoveToTrash;
  GtkWidget *radMarkAsDeleted;
  GtkWidget *lblMarkAsDeleted;
  GtkWidget *radRemove;
  GtkWidget *chkExpungeOnExit;
  GtkWidget *chkEmptyTrashOnExit;
  GtkWidget *fixed5;
  GtkWidget *chkUseSSL;
  GtkWidget *lblNYI;
  GtkWidget *lblAuthentication;
  GtkWidget *cmboAuthentication;
  GList *cmboAuthentication_items = NULL;
  GtkWidget *lblGeneral;
  GtkWidget *lblExtended;
  GtkWidget *lblAdvanced;
  GtkWidget *dialog_action_area2;
  GtkWidget *fixed2;
  GtkWidget *cmdImapEditorCancel;
  GtkWidget *cmdImapEditorOK;

  dlgImapEditor = gtk_dialog_new ();
  gtk_widget_set_name (dlgImapEditor, "dlgImapEditor");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "dlgImapEditor", dlgImapEditor);
  gtk_widget_set_usize (dlgImapEditor, 400, 356);
  gtk_signal_connect_object (GTK_OBJECT (dlgImapEditor), "destroy",
                             GTK_SIGNAL_FUNC (on_dlgImapEditor_destroy),
                             GTK_OBJECT (dlgImapEditor));
  gtk_window_set_title (GTK_WINDOW (dlgImapEditor), _("Spruce: IMAP Editor"));
  gtk_window_position (GTK_WINDOW (dlgImapEditor), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (dlgImapEditor), FALSE, FALSE, FALSE);

  dialog_vbox2 = GTK_DIALOG (dlgImapEditor)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  fixed1 = gtk_fixed_new ();
  gtk_widget_set_name (fixed1, "fixed1");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "fixed1", fixed1);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), fixed1, TRUE, TRUE, 0);

  notebook = gtk_notebook_new ();
  gtk_widget_set_name (notebook, "notebook");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "notebook", notebook);
  gtk_widget_show (notebook);
  gtk_fixed_put (GTK_FIXED (fixed1), notebook, 8, 8);
  gtk_widget_set_uposition (notebook, 8, 8);
  gtk_widget_set_usize (notebook, 384, 280);

  fixed3 = gtk_fixed_new ();
  gtk_widget_set_name (fixed3, "fixed3");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "fixed3", fixed3);
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (notebook), fixed3);

  txtServerName = gtk_entry_new ();
  gtk_widget_set_name (txtServerName, "txtServerName");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "txtServerName", txtServerName);
  gtk_widget_show (txtServerName);
  gtk_fixed_put (GTK_FIXED (fixed3), txtServerName, 120, 16);
  gtk_widget_set_uposition (txtServerName, 120, 16);
  gtk_widget_set_usize (txtServerName, 248, 24);
  if (imap && imap->server.hostname)
     gtk_entry_set_text(GTK_ENTRY(txtServerName), imap->server.hostname);

  lblServerName = gtk_label_new (_("Server Name:"));
  gtk_widget_set_name (lblServerName, "lblServerName");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblServerName", lblServerName);
  gtk_widget_show (lblServerName);
  gtk_fixed_put (GTK_FIXED (fixed3), lblServerName, 8, 16);
  gtk_widget_set_uposition (lblServerName, 8, 16);
  gtk_widget_set_usize (lblServerName, 104, 24);
  gtk_label_set_justify (GTK_LABEL (lblServerName), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblServerName), 1.93715e-07, 0.5);

  lblPort = gtk_label_new (_("Port:"));
  gtk_widget_set_name (lblPort, "lblPort");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblPort", lblPort);
  gtk_widget_show (lblPort);
  gtk_fixed_put (GTK_FIXED (fixed3), lblPort, 8, 48);
  gtk_widget_set_uposition (lblPort, 8, 48);
  gtk_widget_set_usize (lblPort, 104, 24);
  gtk_label_set_justify (GTK_LABEL (lblPort), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblPort), 1.93715e-07, 0.5);

  if (imap && imap->server.port)
     spinPort_adj = gtk_adjustment_new (imap->server.port, 1, 65535, 1, 10, 10);
  else
     spinPort_adj = gtk_adjustment_new (143, 1, 65535, 1, 10, 10);
  spinPort = gtk_spin_button_new (GTK_ADJUSTMENT (spinPort_adj), 1, 0);
  gtk_widget_set_name (spinPort, "spinPort");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "spinPort", spinPort);
  gtk_widget_show (spinPort);
  gtk_fixed_put (GTK_FIXED (fixed3), spinPort, 120, 48);
  gtk_widget_set_uposition (spinPort, 120, 48);
  gtk_widget_set_usize (spinPort, 80, 24);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinPort), TRUE);

  lblUserName = gtk_label_new (_("User Name:"));
  gtk_widget_set_name (lblUserName, "lblUserName");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblUserName", lblUserName);
  gtk_widget_show (lblUserName);
  gtk_fixed_put (GTK_FIXED (fixed3), lblUserName, 8, 80);
  gtk_widget_set_uposition (lblUserName, 8, 80);
  gtk_widget_set_usize (lblUserName, 104, 24);
  gtk_label_set_justify (GTK_LABEL (lblUserName), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblUserName), 1.93715e-07, 0.5);

  txtUserName = gtk_entry_new ();
  gtk_widget_set_name (txtUserName, "txtUserName");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "txtUserName", txtUserName);
  gtk_widget_show (txtUserName);
  gtk_fixed_put (GTK_FIXED (fixed3), txtUserName, 120, 80);
  gtk_widget_set_uposition (txtUserName, 120, 80);
  gtk_widget_set_usize (txtUserName, 248, 24);
  if (imap && imap->login)
     gtk_entry_set_text(GTK_ENTRY(txtUserName), imap->login);

  lblPassword = gtk_label_new (_("Password:"));
  gtk_widget_set_name (lblPassword, "lblPassword");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblPassword", lblPassword);
  gtk_widget_show (lblPassword);
  gtk_fixed_put (GTK_FIXED (fixed3), lblPassword, 8, 112);
  gtk_widget_set_uposition (lblPassword, 8, 112);
  gtk_widget_set_usize (lblPassword, 104, 24);
  gtk_label_set_justify (GTK_LABEL (lblPassword), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblPassword), 1.93715e-07, 0.5);

  txtPasswd = gtk_entry_new ();
  gtk_widget_set_name (txtPasswd, "txtPasswd");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "txtPasswd", txtPasswd);
  gtk_widget_show (txtPasswd);
  gtk_fixed_put (GTK_FIXED (fixed3), txtPasswd, 120, 112);
  gtk_widget_set_uposition (txtPasswd, 120, 112);
  gtk_widget_set_usize (txtPasswd, 248, 24);
  gtk_entry_set_visibility (GTK_ENTRY (txtPasswd), FALSE);
  if (imap && imap->passwd)
     gtk_entry_set_text(GTK_ENTRY(txtPasswd), imap->passwd);

  lblNamespace = gtk_label_new (_("Namespace:"));
  gtk_widget_set_name (lblNamespace, "lblNamespace");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblNamespace", lblNamespace);
  gtk_widget_show (lblNamespace);
  gtk_fixed_put (GTK_FIXED (fixed3), lblNamespace, 8, 192);
  gtk_widget_set_uposition (lblNamespace, 8, 192);
  gtk_widget_set_usize (lblNamespace, 104, 24);
  gtk_label_set_justify (GTK_LABEL (lblNamespace), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblNamespace), 1.93715e-07, 0.5);

  txtNamespace = gtk_entry_new ();
  gtk_widget_set_name (txtNamespace, "txtNamespace");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "txtNamespace", txtNamespace);
  gtk_widget_show (txtNamespace);
  gtk_fixed_put (GTK_FIXED (fixed3), txtNamespace, 120, 192);
  gtk_widget_set_uposition (txtNamespace, 120, 192);
  gtk_widget_set_usize (txtNamespace, 248, 24);
  if (imap && imap->namespace)
     gtk_entry_set_text(GTK_ENTRY(txtNamespace), imap->namespace);

  fixed4 = gtk_fixed_new ();
  gtk_widget_set_name (fixed4, "fixed4");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "fixed4", fixed4);
  gtk_widget_show (fixed4);
  gtk_container_add (GTK_CONTAINER (notebook), fixed4);

  lblWhen = gtk_label_new (_("When I delete a message:"));
  gtk_widget_set_name (lblWhen, "lblWhen");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblWhen", lblWhen);
  gtk_widget_show (lblWhen);
  gtk_fixed_put (GTK_FIXED (fixed4), lblWhen, 8, 8);
  gtk_widget_set_uposition (lblWhen, 8, 8);
  gtk_widget_set_usize (lblWhen, 368, 24);
  gtk_label_set_justify (GTK_LABEL (lblWhen), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblWhen), 1.93715e-07, 0.5);

  lblMoveToTrash = gtk_label_new (_("(It will be removed when I select \"Empty Trash\")"));
  gtk_widget_set_name (lblMoveToTrash, "lblMoveToTrash");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblMoveToTrash", lblMoveToTrash);
  gtk_widget_show (lblMoveToTrash);
  gtk_fixed_put (GTK_FIXED (fixed4), lblMoveToTrash, 24, 56);
  gtk_widget_set_uposition (lblMoveToTrash, 24, 56);
  gtk_widget_set_usize (lblMoveToTrash, 344, 16);
  gtk_label_set_justify (GTK_LABEL (lblMoveToTrash), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblMoveToTrash), 1.93715e-07, 0.5);

  radMoveToTrash = gtk_radio_button_new_with_label (radDeleteMessage_group, _("Move it to the Trash folder."));
  radDeleteMessage_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radMoveToTrash));
  gtk_widget_set_name (radMoveToTrash, "radMoveToTrash");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "radMoveToTrash", radMoveToTrash);
  gtk_widget_show (radMoveToTrash);
  gtk_fixed_put (GTK_FIXED (fixed4), radMoveToTrash, 8, 40);
  gtk_widget_set_uposition (radMoveToTrash, 8, 40);
  gtk_widget_set_usize (radMoveToTrash, 360, 16);

  radMarkAsDeleted = gtk_radio_button_new_with_label (radDeleteMessage_group, _("Mark it as deleted."));
  radDeleteMessage_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radMarkAsDeleted));
  gtk_widget_set_name (radMarkAsDeleted, "radMarkAsDeleted");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "radMarkAsDeleted", radMarkAsDeleted);
  gtk_widget_show (radMarkAsDeleted);
  gtk_fixed_put (GTK_FIXED (fixed4), radMarkAsDeleted, 8, 80);
  gtk_widget_set_uposition (radMarkAsDeleted, 8, 80);
  gtk_widget_set_usize (radMarkAsDeleted, 360, 16);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radMarkAsDeleted), TRUE);

  lblMarkAsDeleted = gtk_label_new (_("(It will be removed when I select \"Compact This Folder\")"));
  gtk_widget_set_name (lblMarkAsDeleted, "lblMarkAsDeleted");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblMarkAsDeleted", lblMarkAsDeleted);
  gtk_widget_show (lblMarkAsDeleted);
  gtk_fixed_put (GTK_FIXED (fixed4), lblMarkAsDeleted, 24, 96);
  gtk_widget_set_uposition (lblMarkAsDeleted, 24, 96);
  gtk_widget_set_usize (lblMarkAsDeleted, 344, 16);
  gtk_label_set_justify (GTK_LABEL (lblMarkAsDeleted), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblMarkAsDeleted), 1.93715e-07, 0.5);

  radRemove = gtk_radio_button_new_with_label (radDeleteMessage_group, _("Remove it immediately."));
  radDeleteMessage_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radRemove));
  gtk_widget_set_name (radRemove, "radRemove");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "radRemove", radRemove);
  gtk_widget_show (radRemove);
  gtk_fixed_put (GTK_FIXED (fixed4), radRemove, 8, 120);
  gtk_widget_set_uposition (radRemove, 8, 120);
  gtk_widget_set_usize (radRemove, 360, 16);

  chkExpungeOnExit = gtk_check_button_new_with_label (_("Clean up (\"Expunge\") Inbox on Exit."));
  gtk_widget_set_name (chkExpungeOnExit, "chkExpungeOnExit");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "chkExpungeOnExit", chkExpungeOnExit);
  gtk_widget_show (chkExpungeOnExit);
  gtk_fixed_put (GTK_FIXED (fixed4), chkExpungeOnExit, 8, 176);
  gtk_widget_set_uposition (chkExpungeOnExit, 8, 176);
  gtk_widget_set_usize (chkExpungeOnExit, 360, 24);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (chkExpungeOnExit), TRUE);

  chkEmptyTrashOnExit = gtk_check_button_new_with_label (_("Empty Trash on Exit."));
  gtk_widget_set_name (chkEmptyTrashOnExit, "chkEmptyTrashOnExit");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "chkEmptyTrashOnExit", chkEmptyTrashOnExit);
  gtk_widget_show (chkEmptyTrashOnExit);
  gtk_fixed_put (GTK_FIXED (fixed4), chkEmptyTrashOnExit, 8, 208);
  gtk_widget_set_uposition (chkEmptyTrashOnExit, 8, 208);
  gtk_widget_set_usize (chkEmptyTrashOnExit, 360, 24);

  fixed5 = gtk_fixed_new ();
  gtk_widget_set_name (fixed5, "fixed5");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "fixed5", fixed5);
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (notebook), fixed5);

  chkUseSSL = gtk_check_button_new_with_label (_("Use secure connection (SSL)."));
  gtk_widget_set_name (chkUseSSL, "chkUseSSL");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "chkUseSSL", chkUseSSL);
  gtk_widget_show (chkUseSSL);
  gtk_fixed_put (GTK_FIXED (fixed5), chkUseSSL, 8, 8);
  gtk_widget_set_uposition (chkUseSSL, 8, 8);
  gtk_widget_set_usize (chkUseSSL, 208, 24);

  lblNYI = gtk_label_new (_("*Not yet implemented*"));
  gtk_widget_set_name (lblNYI, "lblNYI");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblNYI", lblNYI);
  gtk_widget_show (lblNYI);
  gtk_fixed_put (GTK_FIXED (fixed5), lblNYI, 224, 8);
  gtk_widget_set_uposition (lblNYI, 224, 8);
  gtk_widget_set_usize (lblNYI, 152, 24);

  lblAuthentication = gtk_label_new (_("Authentication:"));
  gtk_widget_set_name (lblAuthentication, "lblAuthentication");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblAuthentication", lblAuthentication);
  gtk_widget_show (lblAuthentication);
  gtk_fixed_put (GTK_FIXED (fixed5), lblAuthentication, 8, 40);
  gtk_widget_set_uposition (lblAuthentication, 8, 40);
  gtk_widget_set_usize (lblAuthentication, 120, 24);
  gtk_label_set_justify (GTK_LABEL (lblAuthentication), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (lblAuthentication), 1.93715e-07, 0.5);

  cmboAuthentication = gtk_combo_new ();
  gtk_widget_set_name (cmboAuthentication, "cmboAuthentication");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "cmboAuthentication", cmboAuthentication);
  gtk_widget_show (cmboAuthentication);
  gtk_fixed_put (GTK_FIXED (fixed5), cmboAuthentication, 136, 40);
  gtk_widget_set_uposition (cmboAuthentication, 136, 40);
  gtk_widget_set_usize (GTK_COMBO (cmboAuthentication)->entry, 216, 24);
  gtk_widget_set_usize (cmboAuthentication, 232, 24);
  cmboAuthentication_items = g_list_append (cmboAuthentication_items, _("Plain Text (default)"));
  cmboAuthentication_items = g_list_append (cmboAuthentication_items, _("CRAM-MD5"));
  gtk_combo_set_popdown_strings (GTK_COMBO (cmboAuthentication), cmboAuthentication_items);
  g_list_free (cmboAuthentication_items);
  if (imap)
  {
     switch (imap->authtype)
     {
        case PLAIN:
           gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry), _("Plain Text (default)"));
           break;
        case CRAM_MD5:
           gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry), _("CRAM-MD5"));
           break;
        default:
           break;
     }
  }

  lblGeneral = gtk_label_new (_("General"));
  gtk_widget_set_name (lblGeneral, "lblGeneral");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblGeneral", lblGeneral);
  gtk_widget_show (lblGeneral);
  set_notebook_tab (notebook, 0, lblGeneral);

  lblExtended = gtk_label_new (_("Extended"));
  gtk_widget_set_name (lblExtended, "lblExtended");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblExtended", lblExtended);
  gtk_widget_show (lblExtended);
  set_notebook_tab (notebook, 1, lblExtended);

  lblAdvanced = gtk_label_new (_("Advanced"));
  gtk_widget_set_name (lblAdvanced, "lblAdvanced");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "lblAdvanced", lblAdvanced);
  gtk_widget_show (lblAdvanced);
  set_notebook_tab (notebook, 2, lblAdvanced);

  dialog_action_area2 = GTK_DIALOG (dlgImapEditor)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  fixed2 = gtk_fixed_new ();
  gtk_widget_set_name (fixed2, "fixed2");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "fixed2", fixed2);
  gtk_widget_show (fixed2);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), fixed2, TRUE, TRUE, 0);

  cmdImapEditorCancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cmdImapEditorCancel, "cmdImapEditorCancel");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "cmdImapEditorCancel", cmdImapEditorCancel);
  gtk_widget_show (cmdImapEditorCancel);
  gtk_fixed_put (GTK_FIXED (fixed2), cmdImapEditorCancel, 304, 0);
  gtk_widget_set_uposition (cmdImapEditorCancel, 304, 0);
  gtk_widget_set_usize (cmdImapEditorCancel, 72, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdImapEditorCancel), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdImapEditorCancel_clicked),
                             GTK_OBJECT (dlgImapEditor));

  cmdImapEditorOK = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (cmdImapEditorOK, "cmdImapEditorOK");
  gtk_object_set_data (GTK_OBJECT (dlgImapEditor), "cmdImapEditorOK", cmdImapEditorOK);
  gtk_widget_show (cmdImapEditorOK);
  gtk_fixed_put (GTK_FIXED (fixed2), cmdImapEditorOK, 224, 0);
  gtk_widget_set_uposition (cmdImapEditorOK, 224, 0);
  gtk_widget_set_usize (cmdImapEditorOK, 72, 32);
  gtk_signal_connect_object (GTK_OBJECT (cmdImapEditorOK), "clicked",
                             GTK_SIGNAL_FUNC (on_cmdImapEditorOK_clicked),
                             GTK_OBJECT (dlgImapEditor));

  return dlgImapEditor;
}

void on_frmAccounts_destroy (GtkWidget *widget, gpointer user_data)
{
   gtk_widget_destroy(widget);
   AccountsOpen = FALSE;
   clistPopAccount_row = -1;
   clistImapAccount_row = -1;
}

void on_frmAccounts_show (GtkWidget *widget, gpointer user_data)
{
   if (!first_time)
      refresh_AccountClists(TRUE);
}

void on_clistPopAccounts_select_row (GtkCList *clist, gint row, gint column,
                                     GdkEvent *event, gpointer user_data)
{
   clistPopAccount_row = row;
}

void on_clistImapAccounts_select_row (GtkCList *clist, gint row, gint column,
                                      GdkEvent *event, gpointer user_data)
{
   clistImapAccount_row = row;
}

void on_cmdAccountsCancel_clicked (GtkWidget *widget, gpointer user_data)
{
   /* reread the config file to undo any changes the user made */
   read_accounts();
   gtk_widget_destroy(widget);
}

void on_cmdAccountsOK_clicked (GtkWidget *widget, gpointer user_data)
{
   /* save the changes to the config file */
   rc_save_defaults();
   gtk_widget_destroy(widget);
}

void on_cmdPopAdd_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *dlgPopEditor;

   if (!PopEditorOpen)
   {
      pop_add = TRUE;
      dlgPopEditor = create_dlgPopEditor(NULL);
      gtk_widget_show(dlgPopEditor);
      PopEditorOpen = TRUE;
   }
}

void on_cmdPopEdit_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *dlgPopEditor;

   if (!PopEditorOpen)
   {
      pop_current = g_list_nth_data(PopAccounts, clistPopAccount_row);
      dlgPopEditor = create_dlgPopEditor((PopAccount_t*) pop_current);
      gtk_widget_show(dlgPopEditor);
      PopEditorOpen = TRUE;
   }
}

void on_cmdPopDelete_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *clistPopAccounts = get_widget(widget, "clistPopAccounts");
   guint max;

   if (!PopEditorOpen && clistPopAccount_row > -1)
   {
      gtk_clist_freeze(GTK_CLIST(clistPopAccounts));
      PopAccounts = g_list_remove(PopAccounts, g_list_nth_data(PopAccounts, clistPopAccount_row));
      gtk_clist_remove(GTK_CLIST(clistPopAccounts), clistPopAccount_row);
      max = g_list_length(PopAccounts);
      clistPopAccount_row = clistPopAccount_row >= max ? max - 1 : clistPopAccount_row;
      if (clistPopAccount_row > -1)
         gtk_clist_select_row(GTK_CLIST(clistPopAccounts), clistPopAccount_row, 0);
      gtk_clist_thaw(GTK_CLIST(clistPopAccounts));
   }
}

void on_cmdImapAdd_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *dlgImapEditor;

   if (!ImapEditorOpen)
   {
      imap_add = TRUE;
      dlgImapEditor = create_dlgImapEditor(NULL);
      gtk_widget_show(dlgImapEditor);
      ImapEditorOpen = TRUE;
   }
}

void on_cmdImapEdit_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *dlgImapEditor;

   if (!ImapEditorOpen)
   {
      imap_current = g_list_nth_data(ImapAccounts, clistImapAccount_row);
      dlgImapEditor = create_dlgImapEditor((ImapAccount_t*) imap_current);
      gtk_widget_show(dlgImapEditor);
      ImapEditorOpen = TRUE;
   }
}

void on_cmdImapDelete_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *clistImapAccounts = get_widget(widget, "clistImapAccounts");
   gint max;

   if (!ImapEditorOpen && clistImapAccount_row > -1)
   {
      gtk_clist_freeze(GTK_CLIST(clistImapAccounts));
      ImapAccounts = g_list_remove(ImapAccounts, g_list_nth_data(ImapAccounts, clistImapAccount_row));
      gtk_clist_remove(GTK_CLIST(clistImapAccounts), clistImapAccount_row);
      max = g_list_length(ImapAccounts);
      clistImapAccount_row = clistImapAccount_row >= max ? max - 1 : clistImapAccount_row;
      if (clistImapAccount_row > -1)
         gtk_clist_select_row(GTK_CLIST(clistImapAccounts), clistImapAccount_row, 0);
      gtk_clist_thaw(GTK_CLIST(clistImapAccounts));
   }
}

void on_dlgPopEditor_destroy (GtkWidget *widget, gpointer user_data)
{
   gtk_widget_destroy(widget);
   PopEditorOpen = FALSE;
   pop_add = FALSE;
}

void on_cmdPopEditorCancel_clicked (GtkWidget *widget, gpointer user_data)
{
   gtk_widget_destroy(widget);
}

void on_cmdPopEditorOK_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *txtServerName = get_widget(widget, "txtServerName");
   GtkWidget *spinPort      = get_widget(widget, "spinPort");
   GtkWidget *txtUserName   = get_widget(widget, "txtUserName");
   GtkWidget *txtPasswd     = get_widget(widget, "txtPasswd");
   GtkWidget *cmboMailbox   = get_widget(widget, "cmboMailbox");
   GtkWidget *chkDeleteMail = get_widget(widget, "chkDeleteMail");
   GtkWidget *cmboAuthentication = get_widget(widget, "cmboAuthentication");
   PopAccount_t *pop;

   if (!pop_add)
   {
      pop = (PopAccount_t*)pop_current;
      g_free(pop->server.hostname);
      pop->server.hostname = NULL;
		g_free(pop->login);
      pop->login = NULL;
		g_free(pop->passwd);
      pop->passwd = NULL;
		g_free(pop->mailbox);
      pop->mailbox = NULL;
   }
   else
      pop = g_malloc0(sizeof(PopAccount_t));

   pop->server.hostname = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtServerName)));
   pop->server.port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinPort));
   pop->login = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtUserName)));
   pop->passwd = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtPasswd)));
   pop->mailbox = g_strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(cmboMailbox)->entry)));
   pop->delemail = GTK_TOGGLE_BUTTON(chkDeleteMail)->active;
   pop->authtype = get_authtype(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry)));

   if (pop_add)
      PopAccounts = g_list_append(PopAccounts, pop);

   pop_current = NULL;
   refresh_clistPopAccounts();
   gtk_widget_destroy(widget);
}

void on_dlgImapEditor_destroy (GtkWidget *widget, gpointer user_data)
{
   gtk_widget_destroy(widget);
   ImapEditorOpen = FALSE;
   imap_add = FALSE;
}

void on_cmdImapEditorCancel_clicked (GtkWidget *widget, gpointer user_data)
{
   gtk_widget_destroy(widget);
}

void on_cmdImapEditorOK_clicked (GtkWidget *widget, gpointer user_data)
{
   GtkWidget *txtServerName = get_widget(widget, "txtServerName");
   GtkWidget *spinPort      = get_widget(widget, "spinPort");
   GtkWidget *txtUserName   = get_widget(widget, "txtUserName");
   GtkWidget *txtPasswd     = get_widget(widget, "txtPasswd");
   GtkWidget *txtNamespace  = get_widget(widget, "txtNamespace");
   GtkWidget *cmboAuthentication = get_widget(widget, "cmboAuthentication");
   ImapAccount_t *imap;

   if (!imap_add)
   {
      imap = (ImapAccount_t*)imap_current;
      g_free(imap->server.hostname);
      imap->server.hostname = NULL;
		g_free(imap->login);
      imap->login = NULL;
		g_free(imap->passwd);
      imap->passwd = NULL;
		g_free(imap->namespace);
      imap->namespace = NULL;
      imap = (ImapAccount_t*)imap_current;
   }
   else
      imap = g_malloc0(sizeof(ImapAccount_t));

   imap->server.hostname = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtServerName)));
   imap->server.port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinPort));
   imap->login = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtUserName)));
   imap->passwd = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtPasswd)));
   imap->namespace = g_strdup(gtk_entry_get_text(GTK_ENTRY(txtNamespace)));
   imap->authtype = get_authtype(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(cmboAuthentication)->entry)));

   if (imap_add)
      ImapAccounts = g_list_append(ImapAccounts, imap);

   imap_current = NULL;
   refresh_clistImapAccounts();
   gtk_widget_destroy(widget);
}

conn_auth_t get_authtype(gchar *str)
{
   if (!strcmp(str, _("Plain Text (default)")))
      return (conn_auth_t) PLAIN;
   if (!strcmp(str, _("APOP")))
      return (conn_auth_t) APOP;
   if (!strcmp(str, _("CRAM-MD5")))
      return (conn_auth_t) CRAM_MD5;

   return (conn_auth_t) PLAIN;
}

void null_accounts()
{
   gint i, max;
   PopAccount_t *pop;
   ImapAccount_t *imap;

   max = g_list_length(PopAccounts);
   for (i = 0; i < max; i++)
   {
      pop = g_list_nth_data(PopAccounts, i);
      g_free(pop->server.hostname);
      pop->server.hostname = NULL;
      g_free(pop->login);
      pop->login = NULL;
      g_free(pop->passwd);
      pop->passwd = NULL;
      g_free(pop->mailbox);
      pop->mailbox = NULL;
   }
   g_list_free(PopAccounts);
   PopAccounts = NULL;

   max = g_list_length(ImapAccounts);
   for (i = 0; i < max; i++)
   {
      imap = g_list_nth_data(ImapAccounts, i);
      g_free(imap->server.hostname);
      imap->server.hostname = NULL;
      g_free(imap->login);
      imap->login = NULL;
      g_free(imap->passwd);
      imap->passwd = NULL;
      g_free(imap->namespace);
      imap->namespace = NULL;
   }
   g_list_free(ImapAccounts);
   ImapAccounts = NULL;
}

gint read_accounts()
{
   gchar buffer[512];
   FILE *fp;
   PopAccount_t *pop;
   ImapAccount_t *imap;
   gchar *server  = NULL;
   gchar *mailbox = NULL;
   gchar *namespace = NULL;
   gchar *login   = NULL;
   gchar *passwd  = NULL;
   gchar *port_buff = NULL;
   gchar *del_buff  = NULL;
   gchar *auth_buff = NULL;
   /*gchar *ssl_buff = NULL;*/
   gint port, del, authtype = 0;

   fp = fopen(spruceconf, "rt");
   if (fp == NULL)
	{
      fprintf(stderr, "Spruce: %s failed to open for reading.\n", spruceconf);
      fprintf(stderr, "Please check with your local Administrator.\n");
      return 0;
	}

   null_accounts();

   while (!feof(fp))
	{
      memset(buffer, 0, sizeof(buffer));
      fgets(buffer, sizeof(buffer)-1, fp);
      trim_leadspc(buffer);
      if (buffer[0] != '\n' && buffer[0] != '#')
		{
         if (!strncmp("pop3-server", buffer, strlen("pop3-server")))
         {
            strcut(buffer, 0, strlen("pop3-server"));
            trim_whtspc(buffer);

            server    = get_field(buffer, 1, ':');
            port_buff = get_field(buffer, 2, ':');
            port      = atoi(port_buff);
            g_free(port_buff);
            mailbox   = get_field(buffer, 3, ':');
            login     = get_field(buffer, 4, ':');
            passwd    = get_field(buffer, 5, ':');
            del_buff  = get_field(buffer, 6, ':');
            auth_buff = get_field(buffer, 7, ':');
            del = atoi(del_buff);
            authtype = atoi(auth_buff);
            g_free(del_buff);
            g_free(auth_buff);

            pop = g_malloc0(sizeof(PopAccount_t));

            pop->server.hostname = g_strdup(server);
            g_free(server);
            pop->server.port = (port_t) port;
            pop->mailbox = g_strdup(mailbox);
            g_free(mailbox);
            pop->login = g_strdup(login);
            g_free(login);
            pop->passwd = g_strdup(passwd);
            g_free(passwd);
            pop->delemail = del;
            pop->authtype = (conn_auth_t) authtype;

            PopAccounts = g_list_append(PopAccounts, pop);
         }

         if (!strncmp("imap-server", buffer, strlen("imap-server")))
         {
            strcut(buffer, 0, strlen("imap-server"));
            trim_whtspc(buffer);

            server    = get_field(buffer, 1, ':');
            port_buff = get_field(buffer, 2, ':');
            port = atoi(port_buff);
            g_free(port_buff);
            login     = get_field(buffer, 3, ':');
            passwd    = get_field(buffer, 4, ':');
            auth_buff = get_field(buffer, 5, ':');
            authtype = atoi(auth_buff);
            g_free(auth_buff);
            namespace = get_field(buffer, 6, ':');

            imap = g_malloc0(sizeof(ImapAccount_t));

            imap->server.hostname = g_strdup(server);
            g_free(server);
            imap->server.port = (port_t) port;
            imap->login = g_strdup(login);
            g_free(login);
            imap->passwd = g_strdup(passwd);
            g_free(passwd);
            imap->namespace = g_strdup(namespace);
            g_free(namespace);
            imap->authtype = (conn_auth_t) authtype;

            ImapAccounts = g_list_append(ImapAccounts, imap);
         }
      }
   }

   fclose(fp);
   return 1;
}

void refresh_clistPopAccounts()
{
	GtkWidget *clist = get_widget(frmAccounts, "clistPopAccounts");
   gchar *text[6] = {"", "", "", "", "", ""};
   gchar buffer[512];
   gint i = 0;
   PopAccount_t *pop = NULL;

   gtk_clist_freeze(GTK_CLIST(clist));
   gtk_clist_clear(GTK_CLIST(clist));
   for (i = 0; i < g_list_length(PopAccounts); i++)
   {
      gtk_clist_append(GTK_CLIST(clist), text);
      pop = (PopAccount_t*) g_list_nth_data(PopAccounts, i);
      gtk_clist_set_text(GTK_CLIST(clist), i, 0, pop->server.hostname);
      g_snprintf(buffer, sizeof(buffer)-1, "%d", pop->server.port);
      gtk_clist_set_text(GTK_CLIST(clist), i, 1, buffer);
      switch (pop->authtype)
      {
         case PLAIN:
            gtk_clist_set_text(GTK_CLIST(clist), i, 2, _("Plain Text"));
            break;
         case APOP:
            gtk_clist_set_text(GTK_CLIST(clist), i, 2, _("APOP"));
            break;
         case CRAM_MD5:
            gtk_clist_set_text(GTK_CLIST(clist), i, 2, _("CRAM-MD5"));
            break;
      }
      gtk_clist_set_text(GTK_CLIST(clist), i, 3, pop->login);
      gtk_clist_set_text(GTK_CLIST(clist), i, 4, pop->mailbox);
      if (pop->delemail)
         gtk_clist_set_text(GTK_CLIST(clist), i, 5, _("yes"));
      else
         gtk_clist_set_text(GTK_CLIST(clist), i, 5, _("no"));
   }
   if (clistPopAccount_row > -1)
      gtk_clist_select_row(GTK_CLIST(clist), clistPopAccount_row, 0);

   gtk_clist_thaw(GTK_CLIST(clist));
}

void refresh_clistImapAccounts()
{
   GtkWidget *clist = get_widget(frmAccounts, "clistImapAccounts");
   gchar *text[5] = {"", "", "", "", ""};
   gchar buffer[512];
   gint i;
   ImapAccount_t *imap = NULL;

   gtk_clist_freeze(GTK_CLIST(clist));
   gtk_clist_clear(GTK_CLIST(clist));
   for (i = 0; i < g_list_length(ImapAccounts); i++)
   {
      gtk_clist_append(GTK_CLIST(clist), text);
      imap = (ImapAccount_t*) g_list_nth_data(ImapAccounts, i);
      gtk_clist_set_text(GTK_CLIST(clist), i, 0, imap->server.hostname);
      g_snprintf(buffer, sizeof(buffer)-1, "%d", imap->server.port);
      gtk_clist_set_text(GTK_CLIST(clist), i, 1, buffer);
      switch (imap->authtype)
      {
         case PLAIN:
            gtk_clist_set_text(GTK_CLIST(clist), i, 2, _("Plain Text"));
            break;
         case CRAM_MD5:
            gtk_clist_set_text(GTK_CLIST(clist), i, 2, _("CRAM-MD5"));
            break;
         default:
            break;
      }
      gtk_clist_set_text(GTK_CLIST(clist), i, 3, imap->login);
      gtk_clist_set_text(GTK_CLIST(clist), i, 4, imap->namespace);
   }
   if (clistImapAccount_row > -1)
      gtk_clist_select_row(GTK_CLIST(clist), clistImapAccount_row, 0);
   gtk_clist_thaw(GTK_CLIST(clist));
}

void refresh_AccountClists(gboolean reread)
{
   if (reread)
      read_accounts();

   refresh_clistPopAccounts();
   refresh_clistImapAccounts();
}
