/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __ACCOUNTS_H__
#define __ACCOUNTS_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gtk/gtk.h>
#undef MIN
#undef MAX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gtkmanip.h"
#include "globals.h"
#include "server.h"
#include "accounts_t.h"
#include "options.h"
#include "parse.h"
#include "rc.h"
#include "imap.h"

/* from main.h */
void refresh_mailboxes (gint hilight);

GtkWidget* create_frmAccounts (gint readAccounts);
GtkWidget* create_dlgPopEditor (PopAccount_t *pop);
GtkWidget* create_dlgImapEditor (ImapAccount_t *imap);

void on_frmAccounts_destroy (GtkWidget *widget, gpointer user_data);

void on_frmAccounts_show (GtkWidget *widget, gpointer user_data);

void on_clistPopAccounts_select_row (GtkCList *clist, gint row, gint column, 
                                     GdkEvent *event, gpointer user_data);

void on_clistImapAccounts_select_row (GtkCList *clist, gint row, gint column, 
                                      GdkEvent *event, gpointer user_data);

void on_cmdAccountsCancel_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdAccountsOK_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdPopAdd_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdPopEdit_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdPopDelete_clicked(GtkWidget *widget, gpointer user_data);

void on_cmdImapAdd_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdImapEdit_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdImapDelete_clicked (GtkWidget *widget, gpointer user_data);

/* dlgPopEditor */
void on_dlgPopEditor_destroy(GtkWidget *widget, gpointer user_data);

void on_cmdPopEditorCancel_clicked(GtkWidget *widget, gpointer user_data);

void on_cmdPopEditorOK_clicked(GtkWidget *widget, gpointer user_data);

/* dlgImapEditor */
void on_dlgImapEditor_destroy (GtkWidget *widget, gpointer user_data);

void on_cmdImapEditorCancel_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdImapEditorOK_clicked (GtkWidget *widget, gpointer user_data);


conn_auth_t get_authtype(gchar *str);

void null_accounts(void);

gint read_accounts(void);

void refresh_clistPopAccounts(void);

void refresh_clistImapAccounts(void);

void refresh_AccountClists(gboolean reread);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
