/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __ACCOUNTS_T_H__
#define __ACCOUNTS_T_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "server.h"

#define MAX_ACCOUNTS 16

#define TYPE_POP3 1
#define TYPE_IMAP 2

typedef enum { PLAIN, APOP, CRAM_MD5 } conn_auth_t;

typedef struct {
   Server server;
   gchar *mailbox;
   gchar *login;
   gchar *passwd;
   gboolean delemail; /* used for pop - should it leave a copy on the server? */
   gint type;	       /* 1 for pop3, 2 for imap */
   gint socket;       /* used for imap, and possibly for others in the future */
   conn_auth_t authtype;
} accounts_t;

/* these are the newer structures...
 * I will be using these at a later date */

typedef struct {
   Server server;
   gchar *login;
   gchar *passwd;
   gchar *mailbox;
   gboolean delemail;
   gboolean useSSL;
   conn_auth_t authtype;
} PopAccount_t;

typedef struct {
   Server server;
   gchar *login;
   gchar *passwd;
   gchar *namespace;
   gint socket;
   gboolean useSSL;
   conn_auth_t authtype;
} ImapAccount_t;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
