/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __COMPOSER_H__
#define __COMPOSER_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gtk/gtk.h>
#undef MIN
#undef MAX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "gtkmanip.h"
#include "parse.h"
#include "smtpio.h"

#include "globals.h"

#if defined(ENABLE_GPG) || defined (ENABLE_PGP)
#	include "pgp.h"
#endif

#include "about.h"
#include "addrbook.h"

GtkWidget* create_frmComposer (gchar *sender, gchar *recipient, gchar *cc, gchar *bcc, gchar *subject, gchar *body);
GtkWidget* create_frmComposeSaveAs ();
GtkWidget *create_mnuAttachments(GtkWidget *widget);

void on_frmComposeSaveAs_destroy (GtkWidget *widget, gpointer user_data);

void on_cmdComposeSaveAs_OK_clicked (GtkWidget *widget, gpointer user_data);

void on_cmdComposeSaveAs_Cancel_clicked (GtkWidget *widget, gpointer user_data);

void on_frmComposer_show (GtkWidget *widget, gpointer user_data);

void on_frmComposer_destroy (GtkWidget *widget, gpointer user_data);

void on_cmdComposerAddrBook_clicked (GtkWidget *txtField, gpointer user_data);

void on_mnuComposerFileSend_activate (GtkWidget *widget, gpointer user_data);

void on_cmdComposerSend_clicked (GtkWidget *widget, gpointer data);

void on_mnuComposerFileSave_activate (GtkWidget *widget, gpointer user_data);

void on_cmdComposerSave_clicked (GtkWidget *widget, gpointer data);

void on_mnuComposerFileSave_As_activate (GtkWidget *widget, gpointer user_data);

void on_mnuComposerFilePrint_activate (GtkWidget *widget, gpointer user_data);

void on_cmdComposerPrint_clicked (GtkWidget *widget, gpointer data);

void on_mnuComposerFileClose_activate (GtkWidget *widget, gpointer user_data);

void on_mnuComposerEditCut_activate (GtkWidget *widget, gpointer user_data);

void on_mnuComposerEditCopy_activate (GtkWidget *widget, gpointer user_data);

void on_mnuComposerEditPaste_activate (GtkWidget *widget, gpointer user_data);

void file_insert_ok (GtkWidget *w, GtkFileSelection *fs);

void on_mnuComposerInsertFile_activate (GtkWidget *widget, gpointer user_data);

void on_fileselAttachmentOK_clicked (GtkWidget *button, GtkWidget *filesel);

void on_mnuComposerInsertAttachment_activate (GtkWidget *widget, gpointer user_data);

void on_cmdComposerAttach_clicked (GtkWidget *widget, gpointer data);

void on_mnuComposerInsertSignature_activate (GtkWidget *widget, gpointer user_data);

void on_mnuComposerInsertSpruce_Sig_activate (GtkWidget *widget, gpointer user_data);

void on_mnuComposerHelpAbout_activate (GtkWidget *widget, gpointer user_data);

void on_clistAttachments_button_press_event (GtkWidget *clist, GdkEvent *event, gpointer user_data);

void on_mnuAttachmentsAttach_activate (GtkWidget *widget, gpointer user_data);

void on_mnuAttachmentsRemove_activate (GtkWidget *widget, gpointer user_data);

gint prepare_message(GtkWidget *widget, Email *mesg);

gchar* get_randsig_path();

gint attach_sig(GtkWidget *widget);

gint attach_sigfile(GtkWidget *widget);

gint composer_save_email(GtkWidget *widget, Email *mesg, gchar *filename, gchar *mode);

gchar* SentMailbox();

#if defined(ENABLE_GPG) || defined (ENABLE_PGP)
void on_cmdComposerEncrypt_clicked(GtkWidget *widget, gpointer data);

void Composer_PGP_Encrypt (GtkWidget *widget);
#endif /* defined(ENABLE_GPG) || defined (ENABLE_PGP) */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
