/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, 
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "cram_md5.h"

gchar *cram_md5(gchar *login, gchar *passwd, gchar *MIMEchallenge)
{
  gint i;
  gchar ipad[65];
  gchar opad[65];
  gchar asciidigest[33];
  gchar buffer[256];
  gchar *pw = passwd;
  gint pw_len;
  gchar *encoded;
  md5_byte_t digest[16];
  md5_state_t md5_state;
  gchar *challenge;
  gint MIMElength;

  MIMElength = strlen(MIMEchallenge);
  pw_len = strlen(passwd);
  i = find_string(MIMEchallenge, "+ ");
  if (i != -1)
    MIMEchallenge = MIMEchallenge + i + 2; /* Remove the '+ ' */
  challenge = decode_base64(MIMEchallenge, &MIMElength);
  challenge[MIMElength] = '\0';
  if (strlen(pw) > 64) {
    md5_init(&md5_state);
    md5_append(&md5_state, pw, strlen(passwd));
    md5_finish(&md5_state, digest);
    pw = digest;
    pw_len = 16;
  }
  memset(ipad, '\0', sizeof(ipad));
  memset(opad, '\0', sizeof(opad));
  memcpy(ipad, pw, pw_len);
  memcpy(opad, pw, pw_len);
  
  /* XOR key with ipad and opad values */
  for (i=0;i<64;i++) {
    ipad[i] ^= 0x36;
    opad[i] ^= 0x5c;
  }
  md5_init(&md5_state);
  md5_append(&md5_state, ipad, 64);
  md5_append(&md5_state, challenge, strlen(challenge));
  md5_finish(&md5_state, digest);
  
  md5_init(&md5_state);
  md5_append(&md5_state, opad, 64);
  md5_append(&md5_state, digest, 16);
  md5_finish(&md5_state, digest);

  for(i=0;i<16;i++)
    sprintf(asciidigest+2*i, "%02x", digest[i]);
  strncpy(buffer, login, 255);
  strncat(buffer, " ", 255 - strlen(buffer));
  strncat(buffer, asciidigest, 255 - strlen(buffer));
  
  MIMElength = strlen(buffer);
  encoded = encode_base64(buffer, &MIMElength);
  return (encoded); 
}
