/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __MBOX_H__
#define __MBOX_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <glib.h>
#undef MIN
#undef MAX
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "parse.h"

/* returns whether or not the mailbox is in the mbox format */
gboolean mailbox_is_mbox_format (gchar *mbx, gboolean return_last_retval);

gchar *mbox_to_spruce(gchar *mesg);

gint mbox_rename (gchar *oldpath, gchar *newpath);

guint mbox_get_num_mesgs (gchar *mbx);

gchar *mbox_get_mesg (guint mesg_num, gchar *mbx);

gint mbox_del_mesgs (guint mesgs, guint *mesg_num, gchar *mbox);

gint mbox_copy_mesgs (guint mesgs, guint *mesg_num, gchar *orig_mbox, gchar *new_mbox);

gint mbox_move_mesgs (guint mesgs, guint *mesg_num, gchar *orig_mbox, gchar *new_mbox);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
