/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __OPTIONS_H__
#define __OPTIONS_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gtk/gtk.h>
#undef MIN
#undef MAX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gtkmanip.h"
#include "globals.h"
#include "server.h"
#include "rc.h"
#include "parse.h"
#include "smtpio.h"

#include "accounts.h"
#include "accounts_t.h"

GtkWidget* create_frmOptions (void);
GtkWidget* create_frmBrowseSigFile (void);
GtkWidget* create_frmFontSel (void);

/* frmOptions functions */
void on_frmOptions_destroy (GtkObject *object, gpointer user_data);

void on_frmOptions_show (GtkWidget *widget, gpointer user_data);

void on_cmdOptionsOK_clicked (GtkButton *button, gpointer user_data);

void on_cmdOptionsApply_clicked (GtkButton *button, gpointer user_data);

void on_cmdOptionsCancel_clicked (GtkButton *button, gpointer user_data);

void on_cmdSignatureBrowse_clicked (GtkButton *button, gpointer user_data);

void on_cmdOptionsEdit_clicked (GtkButton *button, gpointer user_data);

void on_cmdOptionsRefresh_clicked (GtkButton *button, gpointer user_data);

void on_cmdOptionsFonts_clicked (GtkWidget *widget, gpointer user_data);

/* frmBrowseSigFile functions */
void on_frmBrowseSigFile_destroy (GtkObject *object, gpointer user_data);

void on_cmdOptionsBrowse_OK_clicked (GtkButton *button, gpointer user_data);

void on_cmdOptionsBrowse_Cancel_clicked (GtkButton *button, gpointer user_data);

/* frmFontSel functions */
void on_frmFontSel_destroy (GtkObject *object, gpointer user_data);

void on_cmdFontSel_OK_clicked (GtkButton *button, gpointer user_data);

void on_cmdFontSel_Cancel_clicked (GtkButton *button, gpointer user_data);

void on_cmdFontSel_Apply_clicked (GtkButton *button, gpointer user_data);

/* other... */
void refresh_clistPopImapAccounts(gint reread);

gint valid_info(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
