#!/usr/bin/perl -w
#
#     Author: David Billsbrough (kc4zvw@mpinet.net)
#
#        $Id: elm2spruce.pl,v 1.1 2000/02/19 16:23:43 fejj Exp $
# 
#    Created: Thursday, February 17, 2000 at 11:49am
#
#   Warranty: None
#
#    Purpose: Convert an elm address book for use with
#           : Spruce X-windows mailer.
#
###------------------------------------------------------###

require strict;

sub get_home_dir
{
	local($myHOME) = $ENV{"HOME"};
	print "My \$HOME directory is $myHOME.\n";
	return($myHOME);
}

sub get_timestamp
{
	local($tmstamp);
	local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst);

	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
		localtime(time);

	$tmstamp = sprintf("%02d-%02d-%04d at %02d:%02d:%02d (local)",
		$mon + 1, $mday, 1900 + $year, $hour, $min, $sec);

	return($tmstamp);
}

sub delete_comment
{
	return substr($_[0], 0, $_[1]);
}

sub get_firstname
{
	return substr($_[0], $_[1] + 2);
}

sub get_lastname
{
	return substr($_[0], 0, $_[1]);
}

sub get_fullname
{
	local ($full_name);
	local ($first_name, $last_name) = @_;

	$full_name = $first_name . " " . $last_name;
	return $full_name;
}

sub display_entry
{
	local ($fullname) = @_;

	print("Converting \"$fullname\" {$.}\n");
}

sub write_spruce_entry
{
	local ($alias, $fullname, $email) = @_;
	local ($count) = $. - 1;

	print OUTPUT "# Address $count\n";			# 
	print OUTPUT "Name: $fullname\n";			# Full Name
	print OUTPUT "Email: $email\n";				# E-mail address
	print OUTPUT "Memo: $alias\n\n";			# Memos field
}

sub write_header
{
	print OUTPUT "# This is a generated file made by elm2spruce.\n";
	print OUTPUT "# Please do NOT edit this by hand, please instead use\n";
	print OUTPUT "# Spruce's address book editor to modify this file.\n";
	print OUTPUT "\n";
}

sub write_footer
{
	print OUTPUT "# End of address book file.\n";
}

sub process_line
{
	local ($line);
	local ($pos1, $pos2);
	local ($alias, $name, $email);
	local ($first) = "";
	local ($last) = "";
	local ($full_name) = "";

	$line = readline(*INPUT);
	chomp($line);							# frag the newline
	($alias, $name, $email) = split(' = ', $line, 3);

	$pos1 = index($name, ',');				# search for a comma
	$pos2 = index($name, ';');				# search for a semicolon
	#print "comma at '$pos1', semicolon at '$pos2'\n";

	if ($pos1 > 0) {
		$name = &delete_comment($name, $pos1);
	}

	$full_name = $name;

	if ($pos2 > 0) {
		$first = &get_firstname($name, $pos2);
		$last = &get_lastname($name, $pos2);
		$full_name = &get_fullname($first, $last);
	}

	&display_entry($full_name)						# display progress
	&write_spruce_entry($alias, $full_name, $email)	# write record
}

###------------------- Main Routine ---------------------###

local ($home) = &get_home_dir;
local ($timestamp);
local ($elm) = join("/", $home, ".elm", "aliases.text");
local ($spruce) = join("/", $home, ".spruce", "addrbook");

print "The elm mail alias file is $elm.\n";
print "The Spuce address book file is $spruce.\n\n";

open(INPUT, '<' . $elm) or die "Can't read input mail aliases : $!";
open(OUTPUT, '>' . $spruce) or die "Can't write output address book : $!";

&write_header;
&process_line until eof(INPUT);
&write_footer;

$timestamp = &get_timestamp;
print "\n";
print "Completed $. records on $timestamp.\n";

close INPUT;
close OUTPUT;

# End of Program
